part of xwidgetbase;

class XfxSchedaTabbed extends StatefulWidget {
  XfxSchedaTabbed({
    Key? key,
    this.titleScheda = "",
    this.visibleXContainerWithLabelOnTop = true,
    this.listOfChildren,
    this.childrenOfTabViewer,
    this.numberOfTabs,
    this.tabs,
    this.bottomNavigationBarvisible = true,
    this.isScrollableTabs = false,
    this.onTapOnBTNofMenu,
    this.currentIndexOfBottomMenu,
    this.backgroundColorTabs,
    required this.childrenOfBottomBar,
  }) : super(key: key);
  final String titleScheda;
  final bool visibleXContainerWithLabelOnTop;
  final List<Widget>? listOfChildren;
  final List<Widget>? childrenOfTabViewer;
  final int? numberOfTabs;
  final bool? bottomNavigationBarvisible;
  final List<Widget>? tabs;
  final bool? isScrollableTabs;
  final int? currentIndexOfBottomMenu;
  final Function(int)? onTapOnBTNofMenu;
  List<BottomNavigationBarItem> childrenOfBottomBar;
  final Color? backgroundColorTabs;
  @override
  _XfxSchedaTabbedState createState() => _XfxSchedaTabbedState();
}

tabViewerPagesSch(String titleScheda, Widget? childOfSchedaTabViewer, List<BottomNavigationBarItem> childrenOfBottomBar) {
  return XfxScheda(bottomNavigationBarvisible: false, titleScheda: titleScheda, child: childOfSchedaTabViewer, childrenOfBottomBar: childrenOfBottomBar);
}

templateSchedaViewerSch(
  String subTitle,
  String descr,
) {
  return Column(
    children: [
      SizedBox(height: 5),
      XContainerWithLabel(
        subTitle,
        color: XColors.xcolor_BackgroundDark,
        alignmentContainer: Alignment.centerLeft,
        textStyle: XStyles.xStyTextForLabel(),
      ),
      SizedBox(height: 5),
      XContainerWithLabel(
        descr,
        color: XColors.xcolor_BackgroundDark,
        alignmentContainer: Alignment.centerLeft,
        textAlignment: TextAlign.left,
        textStyle: XStyles.xStyTextForLabel(),
      ),
    ],
  );
}

tabPagesSch(IconData icon, String? label) {
  return Tab(icon: Icon(icon, color: Colors.white), child: Text(label ?? ""));
}

class _XfxSchedaTabbedState extends State<XfxSchedaTabbed> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: () {},
        child: DefaultTabController(
            length: widget.numberOfTabs!,
            child: Scaffold(
                backgroundColor: XColors.xcolor_BackgroundDark,
                body: Container(
                    margin: EdgeInsets.symmetric(horizontal: 15),
                    child: Column(children: [
                      widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 10) : SizedBox(height: 0),
                      widget.visibleXContainerWithLabelOnTop == true
                          ? Row(
                              children: [
                                Expanded(child: XContainerWithLabel(widget.titleScheda, height: 30, color: xcolor_BackGroundTitleContainerForScheda, textStyle: TextStyle(fontSize: 18, color: Colors.black))),
                              ],
                            )
                          : Container(),
                      widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 3) : SizedBox(height: 0),
                      TabBar(
                        indicator: BoxDecoration(color: widget.backgroundColorTabs ?? Colors.white),
                        isScrollable: widget.isScrollableTabs!,
                        tabs: widget.tabs!,
                      ),
                      SizedBox(height: 3),
                      Expanded(
                        child: Container(
                          child: TabBarView(children: widget.childrenOfTabViewer!),
                        ),
                      ),
                      SizedBox(height: 5),
                    ])),
                bottomNavigationBar: widget.bottomNavigationBarvisible == true
                    ? BottomNavigationBar(
                        type: BottomNavigationBarType.fixed,
                        currentIndex: widget.currentIndexOfBottomMenu ?? 0,
                        onTap: widget.onTapOnBTNofMenu,
                        enableFeedback: true,
                        showUnselectedLabels: true,
                        selectedItemColor: Colors.blue[700],
                        selectedFontSize: 15,
                        selectedLabelStyle: XStyles.xStyleText(),
                        backgroundColor: Colors.grey[900],
                        unselectedItemColor: XColors.xcolor_ForegroundLight,
                        unselectedFontSize: 10,
                        unselectedLabelStyle: XStyles.xStyleText(),
                        iconSize: 20,
                        items: widget.childrenOfBottomBar)
                    : Container(
                        height: 1,
                      ))));
  }
}
